        function []=plotSolution3D(obj,X_d,varargin)
        
        nrPoints=(nargin)/2-1;
              %%%%%%%%%%%%%%%%%%%%%%%%%%
              % collect bounding boxes %
              %%%%%%%%%%%%%%%%%%%%%%%%%%

 
               [pt_min_Cont, pt_max_Cont] = obj.container.getBoundingBox();
               vy1_min1 = pt_min_Cont(1);
               vy2_min1 = pt_min_Cont(2);
               vy1_max1 = pt_max_Cont(1);
               vy2_max1 = pt_max_Cont(2);
               vy3_min1 = pt_min_Cont(3);
               vy3_max1 = pt_max_Cont(3);

               
               [pt_min_Des, pt_max_Des] = obj.design.getBoundingBox(X_d);
               vy1_min2 = pt_min_Des(1);
               vy2_min2 = pt_min_Des(2);
               vy1_max2 = pt_max_Des(1);
               vy2_max2 = pt_max_Des(2);
               vy3_min2 = pt_min_Des(3);
               vy3_max2 = pt_max_Des(3);
               
               

               y1_max = max(vy1_max1,vy1_max2);
               y1_min = min(vy1_min1,vy1_min2);
               y2_max = max(vy2_max1,vy2_max2);
               y2_min = min(vy2_min1,vy2_min2);
               y3_max = max(vy3_max1,vy3_max2);
               y3_min = min(vy3_min1,vy3_min2);
                
              %initialize figure
                s=figure;
                
              %%%%%%%%%%%%%%%%%%
              % plot container %
              %%%%%%%%%%%%%%%%%%

            
              obj.container.plotContainer();

              %%%%%%%%%%%%%%%%
              % plot  design %
              %%%%%%%%%%%%%%%%


              obj.design.plotDesign(X_d);

               hold on
              %%%%%%%%%%%%%%%
              % plot points %
              %%%%%%%%%%%%%%%
              for i=1:nrPoints
                  
                  Y=varargin{2*i-1};
                  color=varargin{2*i};
                  if size(Y,1)~=0
                    
                    scatter3(Y(:,1),Y(:,2),Y(:,3),'MarkerEdgeColor','black','MarkerFaceColor',color);
                  end          
              end

                
              %settings of picture
              
              grid on;


              set(gca, 'DataAspectRatio', [1 1 1]);
              set(gca, 'Units', 'centimeters');
              xlim([y1_min-0.1, y1_max+0.1]);
              ylim([y2_min-0.1, y2_max+0.1]);
              zlim([y3_min-0.1, y3_max+0.1]);

              xlabel('');
              ylabel('');
              zlabel('')
              title('');



        end

    
    


